--Set to false to turn off.
Cfade = true
Uinotice = true
CSounds = true
Altclickinvite = true

--Buttons. Set to Show,or Hide
Emote = "Hide"
Friends = "Hide"
Arrows = true --Set to false to show.
--Buttons. END

print("|cff3399FFw|rChat: Loaded|r");

--Justify --"LEFT","RIGHT", or "CENTER" ChatFrames 1 - 10 
ChatFrame2:SetJustifyH("RIGHT")
--(combatlog) 2,RIGHT 

--chat look
texture = 'Interface\AddOns\wChat\media\WHITE8X8.BLP'

--Timestamp
TIMESTAMP_FORMAT_HHMM = "|r|cff777777[%I:%M]|r "
TIMESTAMP_FORMAT_HHMM_24HR = "|r|cff777777[%H:%M]|r "
TIMESTAMP_FORMAT_HHMM_AMPM = "|r|cff777777[%I:%M %p]|r "

TIMESTAMP_FORMAT_HHMMSS = "|r|cff777777[%I:%M:%S]|r "
TIMESTAMP_FORMAT_HHMMSS_24HR = "|r|cff777777[%H:%M:%S]|r "
TIMESTAMP_FORMAT_HHMMSS_AMPM = "|r|cff777777[%I:%M:%S %p]|r "

--Chat Fade.
if Cfade then
do
	CHAT_FRAME_TAB_NORMAL_NOMOUSE_ALPHA = 0
	CHAT_FRAME_TAB_SELECTED_NOMOUSE_ALPHA = 0
	CHAT_FRAME_BUTTON_FRAME_MIN_ALPHA = 0
	for i=1, 10 do
		local tab = _G[format("%s%d%s", "ChatFrame", i, "Tab")]
		tab:SetAlpha(0)
		tab.noMouseAlpha = 0
	end
end
end

--Sticky Channels, 0 off, 1 on
ChatTypeInfo.EMOTE.sticky = 1
ChatTypeInfo.YELL.sticky = 1
ChatTypeInfo.RAID_WARNING.sticky = 1

--If you want to unsticky whispers or BNet whispers, remove the "--" on the following lines
--ChatTypeInfo.WHISPER.sticky = 0
--ChatTypeInfo.BN_WHISPER.sticky = 0

--Short channel names
CHAT_BATTLEGROUND_GET = "BG %s: "
CHAT_BATTLEGROUND_LEADER_GET = "BGL: %s "
CHAT_SAY_GET = "%s: "
CHAT_YELL_GET = "%s: "
CHAT_WHISPER_GET = "F %s: "
CHAT_WHISPER_INFORM_GET = "T %s: "
CHAT_GUILD_GET = "G %s: "
CHAT_OFFICER_GET = "O %s: "
CHAT_PARTY_GET = "P %s: "
CHAT_PARTY_LEADER_GET = "PL %s: "
HAT_PARTY_GUIDE_GET = "DG %s: "
CHAT_RAID_GET = "R %s: "
CHAT_RAID_LEADER_GET = "RL %s: "
CHAT_RAID_WARNING_GET = "RW %s: "

--Scrolldown
function FloatingChatFrame_OnMouseScroll(self, delta)
	if delta < 0 then
		if IsShiftKeyDown() then self:ScrollToBottom()
		else
			for i = 1, 3 do self:ScrollDown() end end
	elseif delta > 0 then
		if IsShiftKeyDown() then self:ScrollToTop()
		else
			for i = 1, 3 do self:ScrollUp()
			end
		end
	end
end

--Buttons
ChatFrameMenuButton[Emote](ChatFrameMenuButton)
ChatFrameMenuButton.Show = function() end
FriendsMicroButton[Friends](FriendsMicroButton)
FriendsMicroButton.Show = function() end

if Arrows then
do
	local hideFunc = function(frame) frame:Hide() end

	for i = 1, 10 do
		local f = _G[format("%s%d%s", "ChatFrame", i, "ButtonFrame")]
		f:SetScript("OnShow", hideFunc) --Hide the up/down arrows
		f:Hide() --Hide the up/down arrows
	end
end
end

--misc functions (Frame size/move,Arrow keys,editbox to the top) 
do
	for i = 1, 10 do
		local eb =  _G[format("%s%d%s", "ChatFrame", i, "EditBox")]
		local cfs = _G[format("%s%d", "ChatFrame", i)]
		cfs:SetMinResize(0,0)
		cfs:SetMaxResize(0,0)
                cfs:SetClampRectInsets(0,0,0,0)
		eb:ClearAllPoints()
		eb:SetPoint("BOTTOMLEFT",  cfs, "TOPLEFT",  -5, 0)
		eb:SetPoint("BOTTOMRIGHT", cfs, "TOPRIGHT", 5, 0)
		eb:SetAltArrowKeyMode(false)
	end
        --Real ID Frame
	BNToastFrame:SetClampedToScreen(true)
end

--notice
if Uinotice then
local cnot = CreateFrame("Frame")
cnot:RegisterEvent("CHAT_MSG_CHANNEL")
cnot:SetScript("OnEvent", function()
		if string.find(arg1, "WTS%s.*") then
			UIErrorsFrame:AddMessage("|cFFFF0000WTS: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "WTB%s.*") then
			UIErrorsFrame:AddMessage("|cFF0000FFWTB: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "LF%s.*") then
			UIErrorsFrame:AddMessage("|cFF00FF00LFG: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "LFG%s.*") then
			UIErrorsFrame:AddMessage("|cFF00FF00LFG: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
		end
		if string.find(arg1, "LFM%s.*") then
			UIErrorsFrame:AddMessage("|cFF00FF00LFM: |cFFCCCCCC"..arg2..": |cFFFFFF00"..arg1, 1.0, 1.0, 0.0, 1.0, UIERRORS_HOLD_TIME)
     end
end)
end

-- URL Copy
local color = "C0C0C0"
local pattern = "[wWhH][wWtT][wWtT][\46pP]%S+[^%p%s]"

function string.color(text, color)
	return "|cff"..color..text.."|r"
end

function string.link(text, type, value, color)
	return "|H"..type..":"..tostring(value).."|h"..tostring(text):color(color or "ffffff").."|h"
end

StaticPopupDialogs["LINKME"] = {
	text = "URL COPY",
	button2 = CANCEL,
	hasEditBox = true,
    hasWideEditBox = true,
	timeout = 0,
	exclusive = 1,
	hideOnEscape = 1,
	EditBoxOnEscapePressed = function(self) self:GetParent():Hide() end,
	whileDead = 1,
	maxLetters = 255,
}

local function f(url)
	return string.link("["..url.."]", "url", url, color)
end

local function hook(self, text, ...)
	self:f(text:gsub(pattern, f), ...)
end

function LinkMeURL()
	for i = 1, NUM_CHAT_WINDOWS do
		if ( i ~= 2 ) then
			local frame = _G["ChatFrame"..i]
			frame.f = frame.AddMessage
			frame.AddMessage = hook
		end
	end
end
LinkMeURL()

local f = ChatFrame_OnHyperlinkShow
function ChatFrame_OnHyperlinkShow(self, link, text, button)
	local type, value = link:match("(%a+):(.+)")
	if ( type == "url" ) then
		local dialog = StaticPopup_Show("LINKME")
		local editbox = _G[dialog:GetName().."WideEditBox"]  
		editbox:SetText(value)
		editbox:SetFocus()
		editbox:HighlightText()
		local button = _G[dialog:GetName().."Button2"]
            
		button:ClearAllPoints()
           
		button:SetPoint("CENTER", editbox, "CENTER", 0, -30)
	else
		f(self, link, text, button)
	end
end

--Chat copy
local frame = CreateFrame("Frame", "CopyFrame", UIParent)
frame:SetBackdrop({
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true, tileSize = 16, edgeSize = 16,
	insets = {left = 3, right = 3, top = 5, bottom = 3
}})

frame:SetBackdropColor(0, 0, 0, 1)
frame:SetWidth(500)
frame:SetHeight(400)
frame:SetPoint("LEFT", UIParent, "LEFT", 3, 10)
frame:SetFrameStrata("DIALOG")
frame:Hide()

local scrollArea = CreateFrame("ScrollFrame", "CopyFrameScroll", frame, "UIPanelScrollFrameTemplate")
scrollArea:SetPoint("TOPLEFT", frame, "TOPLEFT", 8, -30)
scrollArea:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -30, 8)

editBox = CreateFrame("EditBox", "CopyBox", frame)
editBox:SetMultiLine(true)
editBox:SetMaxLetters(20000)
editBox:EnableMouse(true)
editBox:SetAutoFocus(true)
editBox:SetFontObject(ChatFontNormal)
editBox:SetWidth(450)
editBox:SetHeight(270)
editBox:SetScript("OnEscapePressed", function() frame:Hide() end)

scrollArea:SetScrollChild(editBox)

local close = CreateFrame("Button", "CopyClose", frame, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -1)

local lines = {}
local getLines = function(...)
	local count = 1

	for i = select("#", ...), 1, -1 do
		local region = select(i, ...)
		
		if region:GetObjectType() == "FontString" then
			lines[count] = tostring(region:GetText())
			count = count + 1
		end
	end

	return count - 1
end

local copyChat = function(self, chatTab)
	local chatFrame = _G["ChatFrame" .. chatTab:GetID()]
	local _, fontSize = chatFrame:GetFont()
	
	FCF_SetChatWindowFontSize(chatFrame, chatFrame, 0.01)
	
	local lineCount = getLines(chatFrame:GetRegions())
	
	FCF_SetChatWindowFontSize(chatFrame, chatFrame, fontSize)

	if lineCount > 0 then
		local text = table.concat(lines, "\n", 1, lineCount)

		frame:Show()
		editBox:SetText(text)
	end
end

local info = {
	text = "Copy Chat Contents",
	func = copyChat,
	notCheckable = 1	
}

local origFCF_Tab_OnClick = _G.FCF_Tab_OnClick
local FCF_Tab_OnClickHook = function(chatTab, ...)
	origFCF_Tab_OnClick(chatTab, ...)

	info.arg1 = chatTab
	
	UIDropDownMenu_AddButton(info)
end

FCF_Tab_OnClick = FCF_Tab_OnClickHook

--Chat Sounds
if CSounds then
local name, ns = ...
local mediaPath = [=[Interface\AddOns\wChat\media\]=]
local name = UnitName'player'
local evtsounds = {
	["CHAT_MSG_GUILD"] = "Kachink",
	["CHAT_MSG_OFFICER"] = "Link",
	["CHAT_MSG_PARTY"] = "pop1",
	["CHAT_MSG_PARTY_LEADER"] = "pop2",
	["CHAT_MSG_RAID"] = "Text2",
	["CHAT_MSG_WHISPER"] = "Heart",
	["CHAT_MSG_GMWHISPER"] = "gasp",
	["CHAT_MSG_RAID_LEADER"] = "Choo",
	["CHAT_MSG_BATTLEGROUND"] = "switchy",
	["CHAT_MSG_BATTLEGROUND_LEADER"] = "doublehit",
	["CHAT_MSG_CHANNEL"] = true, --dummy
}

local f = CreateFrame'Frame'
f:SetScript('OnEvent', function(self, event, ...)
	local msg, author, lang, channel = ...
	if author == name then return end
	if event == "CHAT_MSG_CHANNEL" then
		-- TODO
	else
		local sound = mediaPath..evtsounds[event]..'.wav'
		PlaySoundFile(sound)
	end
end)

for event, sound in pairs(evtsounds) do
	f:RegisterEvent(event)
end
end

--Alt click invite.
if Altclickinvite then
local origSetItemRef = SetItemRef
SetItemRef = function(link, text, button)
	local linkType = string.sub(link, 1, 6)
	if IsAltKeyDown() and linkType == "player" then
		local name = string.match(link, "player:([^:]+)")
		InviteUnit(name)
		return nil
	end
	return origSetItemRef(link,text,button)
end

end